import java.io.IOException;

public class BitTreeDecoder {
	short[] Models;
	int NumBitLevels;

	public BitTreeDecoder(int paramInt) {
		this.NumBitLevels = paramInt;
		this.Models = new short[1 << paramInt];
	}

	public void Init() {
		Decoder.InitBitModels(this.Models);
	}

	public int Decode(Decoder paramDecoder) throws IOException {
		int i = 1;
		for (int j = this.NumBitLevels; j != 0; j--) {
			i = (i << 1) + paramDecoder.DecodeBit(this.Models, i);
		}
		return i - (1 << this.NumBitLevels);
	}

	public int ReverseDecode(Decoder paramDecoder) throws IOException {
		int i = 1;
		int j = 0;
		for (int k = 0; k < this.NumBitLevels; k++) {
			int m = paramDecoder.DecodeBit(this.Models, i);
			i <<= 1;
			i += m;
			j |= m << k;
		}
		return j;
	}

	public static int ReverseDecode(short[] paramArrayOfShort, int paramInt1, Decoder paramDecoder, int paramInt2)
			throws IOException {
		int i = 1;
		int j = 0;
		for (int k = 0; k < paramInt2; k++) {
			int m = paramDecoder.DecodeBit(paramArrayOfShort, paramInt1 + i);
			i <<= 1;
			i += m;
			j |= m << k;
		}
		return j;
	}
}
