
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class Decode {
	public OutWindow m_OutWindow = new OutWindow();
	Decoder m_RangeDecoder = new Decoder();
	short[] m_IsMatchDecoders = new short['À'];
	short[] m_IsRepDecoders = new short[12];
	short[] m_IsRepG0Decoders = new short[12];
	short[] m_IsRepG1Decoders = new short[12];
	short[] m_IsRepG2Decoders = new short[12];
	short[] m_IsRep0LongDecoders = new short['À'];
	BitTreeDecoder[] m_PosSlotDecoder = new BitTreeDecoder[4];
	short[] m_PosDecoders = new short[114];
	BitTreeDecoder m_PosAlignDecoder = new BitTreeDecoder(4);
	Decode.LenDecoder m_LenDecoder = new Decode.LenDecoder();
	Decode.LenDecoder m_RepLenDecoder = new Decode.LenDecoder();
	Decode.LiteralDecoder m_LiteralDecoder = new Decode.LiteralDecoder();
	int m_DictionarySize = -1;
	int m_DictionarySizeCheck = -1;
	int m_PosStateMask;

	public Decode() {
		for (int i = 0; i < 4; i++) {
			this.m_PosSlotDecoder[i] = new BitTreeDecoder(6);
		}
	}

	boolean SetDictionarySize() {
		this.m_DictionarySize = (this.m_DictionarySizeCheck = this.m_OutWindow.Create());
		return true;
	}

	boolean SetLcLpPb(int paramInt1, int paramInt2, int paramInt3) {
		if ((paramInt1 > 8) || (paramInt2 > 4) || (paramInt3 > 4)) {
			return false;
		}
		this.m_LiteralDecoder.Create(paramInt2, paramInt1);
		int i = 1 << paramInt3;
		this.m_LenDecoder.Create(i);
		this.m_RepLenDecoder.Create(i);
		this.m_PosStateMask = (i - 1);
		return true;
	}

	void Init() throws IOException {
		this.m_OutWindow.Init(false);
		Decoder.InitBitModels(this.m_IsMatchDecoders);
		Decoder.InitBitModels(this.m_IsRep0LongDecoders);
		Decoder.InitBitModels(this.m_IsRepDecoders);
		Decoder.InitBitModels(this.m_IsRepG0Decoders);
		Decoder.InitBitModels(this.m_IsRepG1Decoders);
		Decoder.InitBitModels(this.m_IsRepG2Decoders);
		Decoder.InitBitModels(this.m_PosDecoders);
		this.m_LiteralDecoder.Init();
		for (int i = 0; i < 4; i++) {
			this.m_PosSlotDecoder[i].Init();
		}
		this.m_LenDecoder.Init();
		this.m_RepLenDecoder.Init();
		this.m_PosAlignDecoder.Init();
		this.m_RangeDecoder.Init();
	}

	public boolean Code(Main paramMain, byte[] paramArrayOfByte, InputStream paramInputStream,
			OutputStream paramOutputStream, int paramInt1) throws IOException {
		this.m_RangeDecoder.SetStream(paramMain, paramArrayOfByte, paramInputStream);
		//if (paramInt2 > 0) {
		//   this.m_OutWindow.SetStream(paramInt2, paramFile);
		// } else {
		this.m_OutWindow.SetStream(paramOutputStream);
		//}
		Init();
		int i = Base.StateInit();
		int j = 0;
		int k = 0;
		int m = 0;
		int n = 0;
		int i1 = 0;
		byte b = 0;
		while ((paramInt1 < 0) || (i1 < paramInt1)) {
			int i2 = i1 & this.m_PosStateMask;
			if (this.m_RangeDecoder.DecodeBit(this.m_IsMatchDecoders, (i << 4) + i2) == 0) {
				Decode.LiteralDecoder.Decoder2 localDecoder2 = this.m_LiteralDecoder.GetDecoder(i1, b);
				if (!Base.StateIsCharState(i)) {
					b = localDecoder2.DecodeWithMatchByte(this.m_RangeDecoder, this.m_OutWindow.GetByte(j));
				} else {
					b = localDecoder2.DecodeNormal(this.m_RangeDecoder);
				}
				this.m_OutWindow.PutByte(b);
				i = Base.StateUpdateChar(i);
				i1++;
			} else {
				int i3;
				if (this.m_RangeDecoder.DecodeBit(this.m_IsRepDecoders, i) == 1) {
					i3 = 0;
					if (this.m_RangeDecoder.DecodeBit(this.m_IsRepG0Decoders, i) == 0) {
						if (this.m_RangeDecoder.DecodeBit(this.m_IsRep0LongDecoders, (i << 4) + i2) == 0) {
							i = Base.StateUpdateShortRep(i);
							i3 = 1;
						}
					} else {
						int i4;
						if (this.m_RangeDecoder.DecodeBit(this.m_IsRepG1Decoders, i) == 0) {
							i4 = k;
						} else {
							if (this.m_RangeDecoder.DecodeBit(this.m_IsRepG2Decoders, i) == 0) {
								i4 = m;
							} else {
								i4 = n;
								n = m;
							}
							m = k;
						}
						k = j;
						j = i4;
					}
					if (i3 == 0) {
						i3 = this.m_RepLenDecoder.Decode(this.m_RangeDecoder, i2) + 2;
						i = Base.StateUpdateRep(i);
					}
				} else {
					n = m;
					m = k;
					k = j;
					i3 = 2 + this.m_LenDecoder.Decode(this.m_RangeDecoder, i2);
					i = Base.StateUpdateMatch(i);
					int i5 = this.m_PosSlotDecoder[Base.GetLenToPosState(i3)].Decode(this.m_RangeDecoder);
					if (i5 >= 4) {
						int i6 = (i5 >> 1) - 1;
						j = (0x2 | i5 & 0x1) << i6;
						if (i5 < 14) {
							j += BitTreeDecoder.ReverseDecode(this.m_PosDecoders, j - i5 - 1, this.m_RangeDecoder, i6);
						} else {
							j += (this.m_RangeDecoder.DecodeDirectBits(i6 - 4) << 4);
							j += this.m_PosAlignDecoder.ReverseDecode(this.m_RangeDecoder);
							if (j < 0) {
								if (j == -1) {
									break;
								}
								return false;
							}
						}
					} else {
						j = i5;
					}
				}
				if ((j >= i1) || (j >= this.m_DictionarySizeCheck)) {
					return false;
				}
				this.m_OutWindow.CopyBlock(j, i3);
				i1 += i3;
				b = this.m_OutWindow.GetByte(0);
			}
		}
		this.m_OutWindow.Flush();
		this.m_OutWindow.ReleaseStream();
		this.m_RangeDecoder.ReleaseStream();
		return true;
	}

	public boolean SetDecoderProperties() {
		if (!SetLcLpPb(3, 0, 2)) {
			return false;
		}
		return SetDictionarySize();
	}

	public void closeWindow() {
		this.m_DictionarySize = (this.m_DictionarySizeCheck = -1);
		this.m_OutWindow._buffer = null;
	}

	class LiteralDecoder {
		Decode.LiteralDecoder.Decoder2[] m_Coders;
		int m_NumPrevBits;
		int m_NumPosBits;
		int m_PosMask;

		LiteralDecoder() {
		}

		public void Create(int paramInt1, int paramInt2) {
			if ((this.m_Coders != null) && (this.m_NumPrevBits == paramInt2) && (this.m_NumPosBits == paramInt1)) {
				return;
			}
			this.m_NumPosBits = paramInt1;
			this.m_PosMask = ((1 << paramInt1) - 1);
			this.m_NumPrevBits = paramInt2;
			int i = 1 << this.m_NumPrevBits + this.m_NumPosBits;
			this.m_Coders = new Decode.LiteralDecoder.Decoder2[i];
			for (int j = 0; j < i; j++) {
				this.m_Coders[j] = new Decode.LiteralDecoder.Decoder2();
			}
		}

		public void Init() {
			int i = 1 << this.m_NumPrevBits + this.m_NumPosBits;
			for (int j = 0; j < i; j++) {
				this.m_Coders[j].Init();
			}
		}

		Decode.LiteralDecoder.Decoder2 GetDecoder(int paramInt, byte paramByte) {
			return this.m_Coders[(((paramInt & this.m_PosMask) << this.m_NumPrevBits)
					+ ((paramByte & 0xFF) >>> 8 - this.m_NumPrevBits))];
		}

		class Decoder2 {
			short[] m_Decoders = new short['̀'];

			Decoder2() {
			}

			public void Init() {
				Decoder.InitBitModels(this.m_Decoders);
			}

			public byte DecodeNormal(Decoder paramDecoder) throws IOException {
				int i = 1;
				do {
					i = i << 1 | paramDecoder.DecodeBit(this.m_Decoders, i);
				} while (i < 256);
				return (byte) i;
			}

			public byte DecodeWithMatchByte(Decoder paramDecoder, byte paramByte) throws IOException {
				int i = 1;
				do {
					int j = paramByte >> 7 & 0x1;
					paramByte = (byte) (paramByte << 1);
					int k = paramDecoder.DecodeBit(this.m_Decoders, (1 + j << 8) + i);
					i = i << 1 | k;
					if (j != k) {
						while (i < 256) {
							i = i << 1 | paramDecoder.DecodeBit(this.m_Decoders, i);
						}
					}
				} while (i < 256);
				return (byte) i;
			}
		}
	}

	class LenDecoder {
		short[] m_Choice = new short[2];
		BitTreeDecoder[] m_LowCoder = new BitTreeDecoder[16];
		BitTreeDecoder[] m_MidCoder = new BitTreeDecoder[16];
		BitTreeDecoder m_HighCoder = new BitTreeDecoder(8);
		int m_NumPosStates = 0;

		LenDecoder() {
		}

		public void Create(int paramInt) {
			while (this.m_NumPosStates < paramInt) {
				this.m_LowCoder[this.m_NumPosStates] = new BitTreeDecoder(3);
				this.m_MidCoder[this.m_NumPosStates] = new BitTreeDecoder(3);
				this.m_NumPosStates += 1;
			}
		}

		public void Init() {
			Decoder.InitBitModels(this.m_Choice);
			for (int i = 0; i < this.m_NumPosStates; i++) {
				this.m_LowCoder[i].Init();
				this.m_MidCoder[i].Init();
			}
			this.m_HighCoder.Init();
		}

		public int Decode(Decoder paramDecoder, int paramInt) throws IOException {
			if (paramDecoder.DecodeBit(this.m_Choice, 0) == 0) {
				return this.m_LowCoder[paramInt].Decode(paramDecoder);
			}
			int i = 8;
			if (paramDecoder.DecodeBit(this.m_Choice, 1) == 0) {
				i += this.m_MidCoder[paramInt].Decode(paramDecoder);
			} else {
				i += 8 + this.m_HighCoder.Decode(paramDecoder);
			}
			return i;
		}
	}
}
